using Luticate2.Auth.Utils.Dbo.Fields;
using Luticate2.Auth.Utils.Dbo.Result;

namespace Luticate2.Auth.Utils.Interfaces
{
    public interface ILuObjectConverterOptions
    {
        ILuConvertersTypeConverter TypeConverter { get; }

        ILuConvertersAllocator Allocator { get; }

        ILuObjectConverterDescriptorOptions DescriptorOptions { get; }
    }

    public interface ILuObjectConverter
    {
        LuResult<object> Convert(object srcObj, object dstObj, LuFieldDbo path, LuPartialFieldsDbo fields, ILuObjectConverterOptions options);
    }

    public interface ILuObjectConverter<TTypeFrom, TTypeTo> : ILuObjectConverter
    {
    }

    public interface ILuObjectConverterIdentity : ILuObjectConverter
    {
    }
}